package main

import (
	"fmt"
	"github.com/go-redis/redis"
	"io"
	"os"
	"strconv"
)

func Exists(path string) bool {
	_, err := os.Stat(path) //os.Stat获取文件信息
	if err != nil {
		if os.IsExist(err) {
			return true
		}
		return false
	}
	return true
}
func getFile(fileName string) *os.File {
	var (
		file *os.File
		err  error
	)
	defer file.Close()
	//文件是否存在
	if Exists(fileName) {
		//使用追加模式打开文件
		file, err = os.OpenFile(fileName, os.O_APPEND, 0666)
		if err != nil {
			fmt.Println("打开文件错误：", err)
			return nil
		}
	} else {
		//不存在创建文件
		file, err = os.Create(fileName)
		if err != nil {
			fmt.Println("创建失败", err)
			return nil
		}
	}
	return file
}
func getClearKeys(matchkey, name, typ string, evt string) {
	clientCfg := &redis.Options{
		Addr:     "r-wz94upxh4iqqyytyfapd.redis.rds.aliyuncs.com:6379", //"r-0xiycu27etmze54u5u.redis.rds.aliyuncs.com:6379", //"r-wz94upxh4iqqyytyfa.redis.rds.aliyuncs.com:6379",
		Password: "crazy_coin2020",                                     //"crazy_coin2020",
		DB:       0,
	}
	if evt == "prod" {
		clientCfg = &redis.Options{
			Addr:     "r-0xi7d247rup0te749x.redis.rds.aliyuncs.com:6379", //"r-0xiycu27etmze54u5u.redis.rds.aliyuncs.com:6379", //"r-wz94upxh4iqqyytyfa.redis.rds.aliyuncs.com:6379",
			Password: "48070906aa076e18=",                                //"crazy_coin2020",
			DB:       0,
		}
	}
	client := redis.NewClient(clientCfg)

	defer func() {
		client.Close()

	}()

	cursor := uint64(0)
	var f func(client *redis.Client, cursor2 uint64)
	i := 0
	sumNum := 0
	f = func(client *redis.Client, cursor2 uint64) {
		key := matchkey + "*"
		//key := "USER_SYS_ATTR:*"
		keysArr, cursor3, err := client.Scan(cursor2, key, 10000).Result()
		//fmt.Printf("keysArr:%+v", keysArr)
		if err == nil {
			num := len(keysArr)
			sumNum += num
			//str, _ := jsoniter.MarshalToString(keysArr)
			//fmt.Printf("keysArr:%+v,cursor:%+v\n", str, cursor3)
			conStr := ""
			for _, ke := range keysArr {
				conStr += ke + ",\n"
			}
			switch typ {
			case "del":
				client.Del(keysArr...)
			case "exp":
			case "log":
				nn := sumNum / 200000
				file := getFile("./Log/" + name + strconv.Itoa(nn) + ".csv")
				io.WriteString(file, conStr)
				fmt.Printf("======keysNum:%+v,cursor:%+v,sumKeys:%+v=====\n", num, cursor3, sumNum)
			}
			//576460752312495455
		} else {
			fmt.Printf("======err:%+v\r\n", err.Error())
		}
		if cursor3 != 0 {
			i++
			//if i >= 10 {
			//	return
			//}
			f(client, cursor3)
		}
	}
	f(client, cursor)
	fmt.Printf("====%v====", i)
}
func main() {
	key := "coupon_"
	getClearKeys(key, "coupon_", "log", "dev")
	//fmt.Println("1111111111111")
}
